#define NO 0
#define YES 1
#define BOTH 2

/*\c
 * \secb{Options for the makefiles}\index{options!makefiles}
 * This part contains some options that control the building of the makefiles.
 */
 
#define USE_ALIAS    YES   /* use alias names for the auxiliary executables */
#define HAVE_FLEX    YES   /* set to NO, if you don't have FLEX on your system */
#define HAVE_DJP     YES   /* use djp (exe file compressor) for MSDOS */
#define GETOPT_DEP   NO    /* include getopt.o in dependencies (lx2l, idl_format) */
#define W_UNUSED     NO    /* include the compiler switch -Wunused for gcc */
#define OPTIMIZE     NO    /* turn on/off compiler optimize */

#if VMS
#  define USE_VAXC   NO    /* (VAX only) if NO, use DECC also for VAX */
#  define USE_MMK    YES   /* if YES, use MMK as make; if no use DEC MMS */
#endif

#define OLD_EMBEDDED_LATEX NO

/*\c
 * \secb{Options for code generation}\index{options!code generation}
 * This part defines some options to exclude some parts of the code from compilation.
 * Because these #defines are read also by lx2l, only the values 1 (to enable an
 * option) or NO (to disable the option) are allowed. If a condition should be true
 * for both branches, you may use the value 2; to disable a condition for both
 * branches, you may use the value 3 (not used).
 */

#define ALLTT_HEADER       YES   /* use <alltt> environment for block headers (idl2ltx) */
#define USE_SUPERTABULAR   NO    /* use the supertabular environment for block headers */
#define BCC_KEYWORDS       YES   /* special keywords for Borland C++ (c2ltx only)*/
#define CALL_LATEX         YES   /* include code for calling LaTeX, xdvi, dvips, print */
#define CFG_FILE           YES   /* include code for reading a configuration file */
#define DEBUG              YES   /* include debug code */
#define DEBUGGER           NO    /* build the exe files for a debugger */
#define EMBEDDED_LATEX     YES   /* include code for embedded LaTeX */
#define GERMAN             YES   /* include rules and some different code for german language */
#define GNU_KEYWORDS       YES   /* special keywords for Gnu C (c2ltx only)*/
#define LEX_YACC_KEYWORDS  YES   /* special keywords for LEX/FLEX and YACC/BISON */
#define LX_IN_ALLTT        YES   /* write the first part of .LX-Files using the alltt environment */
#define USE_ALLTT          YES   /* include code for alltt environment */
#define USE_OMIT           YES   /* include code for omitting lines */
#define USE_PLAIN          YES   /* include rules and code for plain text */
#define USE_WASY           YES   /* use the wasy symbol font */
#define VMS_KEYWORDS       YES   /* special keywords for VAXC/DECC (c2ltx only) */
#define MARK_STARTCONDITION YES   /* use special font for start conditions (c2ltx/lex & yacc only) */

   /* the following #define's modify cvt2ltx_cld.cld (VMS only) */
#define C2L                YES   /* build c2ltx */
#define I2L                YES   /* build idl2ltx */
#define P2L                YES   /* build perl2ltx */
#define T2L                YES   /* build txt2ltx */

#if VMS
#   define VMS_CLI  YES       /* use the VMS-CLI interface */
#   define UNIX_CLI YES       /* use the UNIX-style interface */
#   define USE_FOREIGN_COMMAND YES /* if yes, link the cli definitions to the file 
                                       (required if both interfaces are used) */
#endif
